/*
 * Created on 19.04.2004
 *
 * To change the template for this generated file go to
 * Window>Preferences>Java>Code Generation>Code and Comments
 */

/**
 * @author user
 *
 * To change the template for this generated type comment go to
 * Window>Preferences>Java>Code Generation>Code and Comments
 */

//all used general java-sdk packages...
package app;

import antlr.*;
import antlr.collections.*;
import antlr.debug.misc.*;
//import symbol.*;
//import symbol.visualize.*;

import java.util.List;
import java.util.LinkedList;
import java.util.Iterator;

import antlr.*;
import antlr.collections.AST;

//import PL0.*;

import java.awt.*;
import java.awt.event.*;

import javax.swing.*;
import javax.swing.border.*;
import javax.swing.event.*;
import javax.swing.tree.*;
import javax.swing.text.*;

import java.util.Iterator;

import java.io.*;

import actionListener.*;

import frontend.symbol.*;
import frontend.symbol.visualize.*;
import java.util.*;
import frontend.parser.*;
import frontend.parsetree.*;
import intermediate.*;
import intermediate.visualize.*;

import compiler.*;
import backend.*;
import frontend.*;



public class AppWindow extends JFrame implements compiler.Compiler {


    JPanel dummyPanel = new JPanel();


        JTabbedPane appTab; //containing tabs for source-code/syntax-tree/...
            JSplitPane appSplitPane; //global App-Split pane
                JScrollPane codeScrollPane; //contains the sourceCode
                    JEditorPane codeText;	//contains sourceCode
                JScrollPane errorScrollPane; //contains the error-Msg
                    JTextArea errorMsgText; //prints error-messages

            JSplitPane syntaxSplitPane; //split pane inside the tab containing syntaxTree and symboltable

            JSplitPane intermediateSplitPane; //split pane inside the tab containing syntaxTree and intermediate representation
                JScrollPane intermediateScrollPane; //scrolls the intermediate code-representation
                    JTextArea intermediateText; //contains the intermediate code-representation

    private AST ast;

    private JMenuBar mbar;
    private JMenuItem createSyntaxItem;
    private JMenuItem createIntermediateItem;
    private JMenuItem linearizeIntermediateItem;
    private JMenuItem optimizeCodeItem;
    private JMenuItem createAssemblerItem;
    private JMenuItem writeAsmFileItem;

    private PL0Lexer lexer;
    private PL0Parser parser;
    private TextIntermediatePanel tip;
    private TextIntermediatePanel tipLinear;
//	private static PL0Lexer lexer;
//	private static PL0Parser parser;

    public CodeContainer cc;
    private FrameContainer frameContainer;
    private ImmContainer immCont;


    private PL0Frontend frontend;
    private I386LinuxBackend backend;

    public AppWindow() {
        frontend = new PL0Frontend(this);
        backend = new I386LinuxBackend(this);
        initGUI();
    }

    public Frontend getFrontend() {
        return frontend;
    }

    public Backend getBackend() {
        return backend;
    }


    private void initGUI() {

        //setup the window dimensions/appearance
        setTitle("Hauptseminar Compilerbau 2004");
        setSize(800, 600);
        setLocation(100, 100);
        /**
         * Creates an WindowListener to handle the windowClosing procedure
         */
        addWindowListener(new WindowAdapter() {
            public void windowClosing(WindowEvent e) {
                //calls the window-closing-procedure
                System.exit(0);
            }
        });

        /**
         * creates the Menuparts, set their Mnemonics (alt+"mnemonic-letter")
         * and constucts all them together to attach the final Menu to the Programm-Window
         */
//Menu-Bar
        mbar = new JMenuBar();
        setJMenuBar(mbar);

        JMenu fileMenu = new JMenu("Datei");
        fileMenu.setMnemonic('D');
        mbar.add(fileMenu);

        JMenuItem openFileItem = new JMenuItem("ffnen");
        fileMenu.add(openFileItem);

        fileMenu.addSeparator();

        JMenuItem exitMenuItem = new JMenuItem("Beenden");

        fileMenu.add(exitMenuItem);

        Action openAction = new openFileAL(this);
        openFileItem.addActionListener(openAction);

        Action exitAction = new exitAL();
        exitMenuItem.addActionListener(exitAction);

        JMenu actionMenu = new JMenu("Compilerschritte");
        actionMenu.setMnemonic('C');
        mbar.add(actionMenu);

        createSyntaxItem = new JMenuItem("erzeuge Syntaxbaum");
        createSyntaxItem.setEnabled(true);
        actionMenu.add(createSyntaxItem);

        Action createSyntTreeAction = new createSyntaxTreeAL(this);
        createSyntaxItem.addActionListener(createSyntTreeAction);

        createIntermediateItem = new JMenuItem("erzeuge Zwischensprache");
        createIntermediateItem.setEnabled(false);
        actionMenu.add(createIntermediateItem);

        Action createIntermAction = new createIntermediateAL(this);
        createIntermediateItem.addActionListener(createIntermAction);

        JMenu backendMenu = new JMenu("Backend");
        backendMenu.setMnemonic('B');
        mbar.add(backendMenu);

        linearizeIntermediateItem = new JMenuItem("linearisiere Zwischensprache");
        linearizeIntermediateItem.setEnabled(false);
        backendMenu.add(linearizeIntermediateItem);

        Action createLinImmAction = new createLinearImmAL(this);
        linearizeIntermediateItem.addActionListener(createLinImmAction);

        optimizeCodeItem = new JMenuItem("optimiere Zwischencode");
        optimizeCodeItem.setEnabled(false);
        backendMenu.add(optimizeCodeItem);
        Action optimizeLinImmAction = new optimizeLinearImmAL(this);
        optimizeCodeItem.addActionListener(optimizeLinImmAction);

        createAssemblerItem = new JMenuItem("erzeuge Assembler");
        createAssemblerItem.setEnabled(false);
        backendMenu.add(createAssemblerItem);
        Action createAssemblerAction = new createAssemblerAL(this);
        createAssemblerItem.addActionListener(createAssemblerAction);

        writeAsmFileItem = new JMenuItem("schreibe Binrprogramm");
        writeAsmFileItem.setEnabled(false);
        backendMenu.add(writeAsmFileItem);
        Action writeAsmFileAction = new writeAsmFileAL(this);
        writeAsmFileItem.addActionListener(writeAsmFileAction);

        /**
         * create an TabPane
         */
        appTab = new JTabbedPane();
        /**
         * create Panels and add them to the Pane
         */

//Panel SourceCode
        //codeText = new JTextArea(4, 40);
        //codeText.setBorder(new LineNumberBorder());
        codeText = new JEditorPane();
//        codeText.setEditorKit(new MyRTFEditorKit());
        codeText.setEditable(true);
        codeScrollPane = new JScrollPane(codeText);
        codeScrollPane.setViewportView(codeText);

        LineNumber lineNumber = new LineNumber( codeText );
        codeScrollPane.setRowHeaderView( lineNumber );

//		create ErrorMessage TextArea
              errorMsgText = new JTextArea();
                //errorMsgText.setBounds(1,1,100,100);
              errorScrollPane = new JScrollPane(errorMsgText);
              errorScrollPane.setViewportView(errorMsgText);
              //errorScrollPane.setBounds(0,0,300,500);

              TitledBorder titleErrorMsg;
              titleErrorMsg = BorderFactory.createTitledBorder("Fehlermeldungen");
              errorScrollPane.setBorder(titleErrorMsg);

        appSplitPane =
                new JSplitPane(
                JSplitPane.VERTICAL_SPLIT,
                true,
                codeScrollPane,
                errorScrollPane);
        appSplitPane.setDividerLocation(400);

        appTab.addTab("Quellcode", appSplitPane);
//        appTab.setPreferredSize(new Dimension(100,400));


//Panel SyntaxTree

        appTab.addTab("Syntaxtabelle", new JPanel());

//Panel Zwischencode
        appTab.addTab("Zwischencode", new JPanel());

//Panel linear Zwischencode
        appTab.addTab("Linearisierter Zwischencode", new JPanel());

//Panel optimierter Zwischencode
        appTab.addTab("Optimierter Zwischencode", new JPanel());

//Panel Assemblercode
        appTab.addTab("Assemblercode", new JPanel());

        getContentPane().add(appTab);

    }

    class MyTreeSelectionListener implements TreeSelectionListener {

        public void valueChanged(TreeSelectionEvent event) {
            TreePath path = event.getPath();
            System.out.println("Selected: " +
                    path.getLastPathComponent());
            Object elements[] = path.getPath();
            for (int i = 0; i < elements.length; i++) {
                System.out.print("->" + elements[i]);
            }
            System.out.println();
        }
    }

    public void readFile(String fileName) {
        try {
            BufferedReader file = new BufferedReader(new FileReader(fileName));
            String line;
            StringBuffer completeText = new StringBuffer();
            codeText.setText(null);

            // read the first line
            if ((line = file.readLine()) != null) {

                do {
                    //codeText.getText().append(line + "\n");
                    completeText.append(line).append("\n");
                    line = file.readLine();
                }
                while (line != null);
                try {
                    codeText.getDocument().insertString(0, completeText.toString(), null);
                }
                catch (BadLocationException ex) {
                }
            }

        }
        catch (Exception er) {
            System.err.println(er.getMessage());
            er.printStackTrace();
            printErrorCode(er.getMessage());
        }

    }

    public void insertSyntaxTree(String sourceCodeComponent) {
        boolean exceptionsfound = false;
        SymbolTable.getSymbolTable().reset();
        lexer = new PL0Lexer(new StringBufferInputStream(sourceCodeComponent));
        parser = new PL0Parser(lexer);
        //Beginne Parsen bei Startregel (program)
        try {
            parser.program();
        }
        //fange ANTLR Exceptions beim Scannen oder Parsen und gib sie aus
        catch (RecognitionException ex) {
            String errormsg = "Error at line " + ex.getLine() + ":" + ex.getColumn() +
                    ": " + ex.getMessage();
            printErrorCode(errormsg);
            exceptionsfound = true;
        }

        catch (TokenStreamException ex) {
            //Fehlermeldung ist Standardmeldung der Exception
            String errormsg = ex.toString();
            //Wenn Exception TokenStreamRecognitionException ist, knnen wir die Fehlermeldung
            //in das Format unseres Parsers bringen.
            if (ex instanceof TokenStreamRecognitionException) {
                RecognitionException rex = ((TokenStreamRecognitionException)ex).recog;
                errormsg = "Error at line " + rex.getLine() + ":" + rex.getColumn() +
                        ": " + ex.getMessage();
            }
            printErrorCode(errormsg);
            exceptionsfound = true;
        }

        //Wenn es keine ANTLR Exceptions gab, gib Exceptions der Symboltabelle aus.
        if (!exceptionsfound && parser.getExceptions().size() > 0) {
            for (Iterator it = parser.getExceptions().iterator(); it.hasNext(); ) {
                printErrorCode((String)it.next());
            }
            exceptionsfound = true;
        }

        //Wenn es keine Fehler gab, baue den Baum und zeige ihn an, auerdem zeige Symtab an
        if (!exceptionsfound) {

            //Baue Syntaxbaum (Abstract Syntax Tree)
            ast = parser.getAST();
            TreeSelectionListener listener = new MyTreeSelectionListener();
            System.out.println(ast.toStringList());
            JTreeASTPanel treeP = new JTreeASTPanel(new JTreeASTModel(ast), null);
                TitledBorder titleSyntaxTree;
                titleSyntaxTree = BorderFactory.createTitledBorder("Syntaxbaum");
                treeP.setBorder(titleSyntaxTree);

            // Zeige Sichtbarkeitsbereiche der Symboltabelle grafisch

            JTreeSymtabModel treeModel = new JTreeSymtabModel();
            JTreeSymtabPanel treePanel = new JTreeSymtabPanel(treeModel);
                    TitledBorder titleViewTree;
                    titleViewTree = BorderFactory.createTitledBorder("Gltigkeitsbereiche");
                    treePanel.setBorder(titleViewTree);

                JTableSymtabPanel tablePanel = new JTableSymtabPanel(treePanel.getTree());
                    TitledBorder titleSymTab;
                    titleSymTab = BorderFactory.createTitledBorder("Symboltabelle");
                    tablePanel.setBorder(titleSymTab);

            JPanel treeAndTable = new JPanel();
            treeAndTable.setLayout(new BoxLayout(treeAndTable, BoxLayout.X_AXIS));
            treeAndTable.add(treePanel);
            treeAndTable.add(Box.createHorizontalStrut(10));
            treeAndTable.add(tablePanel);

            //construct panel containing syntaxTree and symbolTable

            syntaxSplitPane =
                    new JSplitPane(
                    JSplitPane.VERTICAL_SPLIT,
                    false,
                    treeP,
                    treeAndTable);

            syntaxSplitPane.setDividerLocation(200);

            appTab.setComponentAt(1, syntaxSplitPane);


        }

    }


    public void insertIntermediate() {
//		**********************************
//		 try... some things...
         //Baue Syntaxbaum (Abstract Syntax Tree) und erzeuge Symboltabelle

        cc = ((ProcedureNode)parser.getAST()).createIntermediateCode();
        frameContainer = setupFrameContainer();
        JTreeSymtabModel treeModel = new JTreeSymtabModel();
        JTreeSymtabPanel treePanel = new JTreeSymtabPanel(treeModel);
                TitledBorder titleViewTree;
                titleViewTree = BorderFactory.createTitledBorder("Gltigkeitsbereiche");
                treePanel.setBorder(titleViewTree);


         //Erzeuge Anzeige fr Zwischencodebaum und melde sie als Listener am Gltigkeitsbereichbaum an

         final JTreeIntermediateModel jtim = new JTreeIntermediateModel(cc.getCode(0));
         final JTreeIntermediatePanel intermediateTreePanel = new JTreeIntermediatePanel(jtim);
            TitledBorder titleIntermdediateTree;
            titleIntermdediateTree = BorderFactory.createTitledBorder("Zwischencodebaum");
            intermediateTreePanel.setBorder(titleIntermdediateTree);

         treePanel.getTree().addTreeSelectionListener(new TreeSelectionListener() {
             public void valueChanged(TreeSelectionEvent e) {
                 Object[] sdefs = e.getPath().getPath();
                 ScopeDef currentScope = (ScopeDef)sdefs[sdefs.length - 1];
                 int number = currentScope.getScopeNumber();
                 JTree tree = intermediateTreePanel.getTree();
                 jtim.setRoot(cc.getCode(number));
             }
         });
         if (cc.getCode(0) != null) {
             tip = new TextIntermediatePanel(cc.getCode(0).toStringList());
         } else {
             tip = new TextIntermediatePanel("<leer>");
         }
            TitledBorder titleIntermdediateText;
            titleIntermdediateText = BorderFactory.createTitledBorder("Zwischencode");
            tip.setBorder(titleIntermdediateText);

         treePanel.getTree().addTreeSelectionListener(new TreeSelectionListener() {
             public void valueChanged(TreeSelectionEvent e) {
                 Object[] sdefs = e.getPath().getPath();
                 ScopeDef currentScope = (ScopeDef)sdefs[sdefs.length - 1];
                 int number = currentScope.getScopeNumber();
//				printErrorCode(new Integer(number).toString());
                 if (cc.getCode(number) != null) {
                     tip.setText(cc.getCode(number).toStringList());
                 } else {
                     tip.setText("<leer>");
                 }
//				 System.out.println(cc.getCode(number).toStringList());
             }
         });






//		**********************************
//		creates the intermediate tab


                  JPanel iTreeAndTable = new JPanel();
                  iTreeAndTable.setLayout(new BoxLayout(iTreeAndTable, BoxLayout.X_AXIS));
                  iTreeAndTable.add(treePanel);
                  iTreeAndTable.add(Box.createHorizontalStrut(10));
                  iTreeAndTable.add(intermediateTreePanel);


                  intermediateSplitPane =
                          new JSplitPane(
                          JSplitPane.VERTICAL_SPLIT,
                          false,
                          iTreeAndTable,
                          tip);

                  intermediateSplitPane.setDividerLocation(200);

                  appTab.setComponentAt(2, intermediateSplitPane);


    }

    public void insertLinearizedIntermPanel(){

        tipLinear = new TextIntermediatePanel(immCont.getLinearCode());
           TitledBorder titleIntermdediateText;
           titleIntermdediateText = BorderFactory.createTitledBorder("Linearisierter Zwischencode");
           tipLinear.setBorder(titleIntermdediateText);

        appTab.setComponentAt(3, tipLinear);
    }

    public void insertOptimizedIntermPanel(){

        TextIntermediatePanel tipOptimized = new TextIntermediatePanel(immCont.getOptimizedCode());
           TitledBorder titleIntermdediateText;
           titleIntermdediateText = BorderFactory.createTitledBorder("Optimierter Zwischencode");
           tipOptimized.setBorder(titleIntermdediateText);

        appTab.setComponentAt(4, tipOptimized);
    }

    public void insertAssemblerPanel(){

                      TextIntermediatePanel tipOptimized = new TextIntermediatePanel(immCont.getAssemblerCode());
                         TitledBorder titleIntermdediateText;
                         titleIntermdediateText = BorderFactory.createTitledBorder("erzeugter Assembler");
                         tipOptimized.setBorder(titleIntermdediateText);

                      appTab.setComponentAt(5, tipOptimized);
    }

    public String getCodeTAString() {
        Document d = codeText.getDocument();
        try {
            return d.getText(0, d.getLength());
        }
        catch (BadLocationException ex) {
            return "";
        }
    }

    public void clearErrorCode(){
        errorMsgText.setText("");
    }

    public void printErrorCode(String s) {
        errorMsgText.append(s + "\n");
    }

    public CodeContainer getCodeContainer(){
        return cc;
    }

    public ImmContainer getImmContainer(){
        return immCont;
    }

    public void setImmContainer(ImmContainer immCont){
        this.immCont = immCont;
    }

    public void enableMenuItems(boolean a, boolean b, boolean c, boolean d, boolean e, boolean f){
        createSyntaxItem.setEnabled(a);
        createIntermediateItem.setEnabled(b);
        linearizeIntermediateItem.setEnabled(c);
        optimizeCodeItem.setEnabled(d);
        createAssemblerItem.setEnabled(e);
        writeAsmFileItem.setEnabled(f);

    }

    /**
     * Erzeugen des FrameContainers und Fllen desselben mit linearisiertem Zwischencode
     */
    public FrameContainer setupFrameContainer() {
        FrameContainer fc = new FrameContainer();
        SymbolTable table = SymbolTable.getSymbolTable();
        processScope(table.getBaseScope(), fc);
        return fc;
    }

    /**
     * Rekursives Einfgen des Hauptprogramms und der Prozeduren in den FrameContainer
     */
    private void processScope(ScopeDef sd, FrameContainer fc) {
        SymbolTable table = SymbolTable.getSymbolTable();
        table.pushScope(sd);
        int nrOfDefs = 0;
        int nrOfConsts = 0;
        LinkedList constDefs = new LinkedList();
        ArrayList defs = new ArrayList();
        for (Iterator it = sd.getElements().keySet().iterator(); it.hasNext();) {
            String name = (String)it.next();
            Definition d = table.lookup(name);
            if (d instanceof VariableDef) {
                nrOfDefs++;
            }
            if (d instanceof ConstantDef) {
                nrOfDefs++;
                nrOfConsts++;
                constDefs.add(d);
                defs.add(null);
            }
        }
         //In der obigen Iteration ist nicht sichergestellt, dass die Konstanten in der richtigen
         //Reihenfolge in der Liste landen (Reihenfolge ihrer Definition). Das holen wir
         //hier nach.
        for (Iterator it2 = constDefs.iterator(); it2.hasNext();) {
            ConstantDef cd = (ConstantDef)it2.next();
            int position = cd.getPosInScope();
            defs.set(position, new Integer(cd.getValue()));

        }
        fc.addFrame(new I386Frame(nrOfDefs, nrOfConsts, defs), sd.getScopeNumber());

        for (Iterator itScope = sd.scopeIdentifiers(); itScope.hasNext();) {
            //ScopeDef sd = (ScopeDef)itScope.next();
            processScope((ScopeDef)itScope.next(), fc);
        }
        table.popScope();

    }

    public FrameContainer getFrameContainer() {
        return frameContainer;
    }



}
