package backend.operators;

import backend.AsmStatement;

public class AsmBranch extends AsmStatement {

  private int trueLabelID, falseLabelID;
  private String trueLabelName;
  private String falseLabelName;
  private Register comp;
  private AsmLabel targetTrue, targetFalse;


/*  public AsmJump(String destination) {
    this.destLabelID = destination;
  }
*/
  public AsmBranch(int compReg, String trueLabel, String falseLabel) {
    comp = new Register(compReg);
    trueLabelName = trueLabel;
    falseLabelName = falseLabel;
    trueLabelID = 0;
    falseLabelID = 0;
    targetTrue = null;
    targetFalse= null;
  }

  public String toString() {
    String retval1, retval2;
    if (trueLabelID==0) retval1=trueLabelName;
    else retval1=String.valueOf(trueLabelID);
    if (falseLabelID==0) retval2=falseLabelName;
    else retval2=String.valueOf(falseLabelID);
    return "BRANCH " + retval1 + "/" + retval2 + " ("+comp.toString()+"?)";
  }

  public String getTrueLabelName() {
    return trueLabelName;
  }

  public String getFalseLabelName() {
    return falseLabelName;
  }

  public void setTrueLabel(AsmLabel label) {
    targetTrue = label;
  }

  public void setFalseLabel(AsmLabel label) {
    targetFalse = label;
  }


}
