package backend.operators;

import backend.AsmStatement;
import backend.BinarFile;

public class AsmFB extends AsmStatement {

  private int block;

  public AsmFB(int block) {
    this.block = block;
    length = 55; /* 5 + 5 mal Anz. lokaler Variablen+Konstanten */
  }

  public String toString() {
      return "FrameBuild " + String.valueOf(block);
  }

  public byte[] getCode (byte[] list, int off) {
    int value;

    /* mov esp => ebp */
    list[off  ] = (byte)(0x89);  // mov opcode
    list[off+1] = (byte)(0xe5);  // esp=>ebp
    /* add $0x0c, ebp */
    list[off+2] = (byte)(0x83);  // add
    list[off+3] = (byte)(0xc5);  // ebp
    list[off+4] = (byte)(0x0c);  // $0x0c

    /* push every var/const */
    for (int i=1; i<=10/* Anz. lokaler Variablen+Konstanten */; i++) {
      value = 0; /* bei Variablen 0 (vorinitialisiert), bei Konstanten der Wert */
      list[off+5*i] = (byte)(0x68);  // push-imm opcode
      list = BinarFile.WriteLongToByteList(value, list, off+5*i+1);  // imm32
    }

    return list;
  }

}
