package backend.operators;

import backend.BinarFile;

public class AsmFBMain extends AsmFB {

  public AsmFBMain(int block) {
    super(block);
    if (block!=0) System.out.println("AsmFBMain(): Error");
    length = /*15*/5 + super.getLength();
  }

  public byte[] getCode (byte[] list, int off) {

    /* simulate Call-Frame */

    list[off  ] = (byte)(0x55);  // push ebp
    list[off+1] = (byte)(0x89);  // mov
    list[off+2] = (byte)(0xe5);  // esp=>ebp
    list[off+3] = (byte)(0x55);  // push ebp
    list[off+4] = (byte)(0x55);  // push ebp

    /* build normal frame */
    list = super.getCode(list,off+5);

    return list;
  }

  public byte[] getCodeCausesError (byte[] list, int off) {

    /* simulate Call-Frame */
    list[off] = (byte)(0x68);  // push opcode
    list = BinarFile.WriteLongToByteList(0x00, list, off+1);  // imm32

    list[off+5] = (byte)(0x68);  // push opcode
    list = BinarFile.WriteLongToByteList(0x00, list, off+6);  // imm32

    list[off+10] = (byte)(0x68);  // push opcode
    list = BinarFile.WriteLongToByteList(0x00, list, off+11);  // imm32

    /* build normal frame */
    list = super.getCode(list,off+15);

    return list;
  }


}
