package backend.operators;

import backend.AsmStatement;
import backend.BinarFile;

public class AsmLIT extends AsmStatement {

  private int value;
  private Register register;

  public AsmLIT(int reg, int val) {
    register = new Register(reg);
    value = val;
    this.length = 5;
  }

  public String toString() {
      return "LIT " + String.valueOf(value) + " => " + register.toString();
  }

  public byte[] getCode (byte[] list, int off) {
    byte opcode = (byte)(0xb8 + register.get());

    list[off] = opcode;
    BinarFile.WriteLongToByteList(value, list, off+1);

    return list;
  }

}
