package backend.operators;

import backend.AsmStatement;

public class AsmLoadFP extends AsmStatement {

  private Register register;

  public AsmLoadFP(int reg) {
    register = new Register(reg);
    length = 2;
  }

  public String toString() {
      return "LOAD Temp fp => " + register.toString();
  }

  public byte[] getCode (byte[] list, int off) {

    /* mov ebp=>register */
    list[off  ] = (byte) (0x89);  // mov
    list[off+1] = (byte) (0xe8 + register.get());  // ebp=>register

    return list;
  }

}
