package backend.operators;

import backend.AsmStatement;
import backend.BinarFile;
import backend.operators.*;


public class AsmOutput extends AsmStatement {

  private Register register;
  private String labelName;
  private AsmLabel output;

  public AsmOutput(int fromRegister) {
    register = new Register(fromRegister);
    labelName = "Output";
    length = 9;
  }

  public String toString() {
    return "OUTPUT <= " + register.toString();
  }

  public String getLabelName() {
    return labelName;
  }

  public void setTargetLabel(AsmLabel label) {
    output = label;
  }

  public byte[] getCode (byte[] list, int off) {

    /* save all registers */
    list[off] = (byte) (0x60); // pushad

    /* load eax */
    list[off + 1] = (byte) (0x8b); // mov
    list[off + 2] = (byte) (0xc0 + register.get()); // register=> eax

/* TEST-SZENARIO
    list[off + 3] = NOP; // NOP
    list[off + 4] = NOP; // NOP
    list[off + 5] = NOP; // NOP
    list[off + 6] = NOP; // NOP
    list[off + 7] = NOP; // NOP
//*/

    /* call OutputCode */
    list[off + 3] = (byte) (0xe8); // call opcode

    if (output == null) System.out.println("OUTPUT = NULL!");
    int value = output.getPos() - this.getPos();
    value -= this.getLength();
    list = BinarFile.WriteLongToByteList(value, list, off + 4);

    /* reload all registers */
    list[off + 8] = (byte) (0x61); // popad

    return list;
  }

}
