package backend.operators;

import backend.AsmStatement;
import backend.BinarFile;

public class AsmStoreTemp extends AsmStatement {

  private Register register;
  private int temp;

  public AsmStoreTemp(int reg, int temp) {
    register = new Register(reg);
    this.temp = temp;
    length = 10;
  }

  public String toString() {
    return "STORE " + register.toString() + " => Temp" + String.valueOf(temp);
  }

  public byte[] getCode (byte[] list, int off) {

    /* save ebp */
    list[off  ] = (byte) (0x55);  // push ebp

    /* load HS-addr to ebp */
    list[off+1] = (byte) (0xbd);  // mov ebp,
    int value = userData + (4 * temp);
    list = BinarFile.WriteLongToByteList(value, list, off+2);  // imm32

    /* load value to HS-addr (=[ebp]) */
    list[off+6] = (byte) (0x89);  // mov
    list[off+7] = (byte) (0x45 + 8*register.get());  // reg=>[ebp]+disp8
    list[off+8] = (byte) (0x00);  // disp8

    /* reload ebp */
    list[off+9] = (byte) (0x5d);  // pop ebp

    return list;
  }

}
