package backend.operators;

public class AsmSub extends BinOp {

  public AsmSub(int reg, int op_reg) {
    super(reg,op_reg);
    length = 2;
  }

  public String toString() {
      return "SUB " + src_dest.toString() + " -= " + operand.toString();
  }

  public byte[] getCode (byte[] list, int off) {
    list[off  ] = (byte)(0x29);  //sub
    list[off+1] = (byte)(0xc0 + src_dest.get() + 8*operand.get());  //r32 from r/m32 == operand from src_dest
    return list;
  }

}
