// $ANTLR 2.7.3: "PL0_Grammar.g" -> "PL0Parser.java"$

package frontend.parser;
import frontend.symbol.*;
import java.util.LinkedList;

import antlr.TokenBuffer;
import antlr.TokenStreamException;
import antlr.TokenStreamIOException;
import antlr.ANTLRException;
import antlr.LLkParser;
import antlr.Token;
import antlr.TokenStream;
import antlr.RecognitionException;
import antlr.NoViableAltException;
import antlr.MismatchedTokenException;
import antlr.SemanticException;
import antlr.ParserSharedInputState;
import antlr.collections.impl.BitSet;
import antlr.collections.AST;
import java.util.Hashtable;
import antlr.ASTFactory;
import antlr.ASTPair;
import antlr.collections.impl.ASTArray;

public class PL0Parser extends antlr.LLkParser       implements PL0TokenTypes
 {

	SymbolTable symbolTable = SymbolTable.getSymbolTable();
	private boolean pendingMinus = false;
	private LinkedList exceptions = new LinkedList();


    //-------------------------------------------------------------------------
    // Symboltable adapter methods
    // The following methods are provided to give a single set of entry
    // calls into the symbol table.  This makes it easy to add debugging
    // code that will track all calls to symbolTable.popScope, for instance
    // These are direct pass-through calls to the symbolTable, but a
    // few have special function.
    //-------------------------------------------------------------------------

    public void popScope() {
    	symbolTable.popScope();
    }

	public LinkedList getExceptions() {
		return exceptions;
	}

    public void defineConst(Token constant, Token value) {
    	Symbol s = new Symbol(constant, Symbol.SYMBOL_CONST);
    	try {
	        symbolTable.defineConst(s, Integer.parseInt(value.getText()));
	    }
	    catch(DoubleDeclarationException e) {
	    	exceptions.add(e.getMessage());
	    }
    }

    public void defineVar(Token var) {
    	Symbol s = new Symbol(var, Symbol.SYMBOL_VAR);
    	try {
	        symbolTable.defineVar(s);
	    }
	    catch(DoubleDeclarationException e) {
	    	exceptions.add(e.getMessage());
	    }
    }

    public void defineProcedure(Token procName) {
    	Symbol s = new Symbol(procName, Symbol.SYMBOL_PROC);
    	try {
	        symbolTable.defineProcedure(s);
	    }
	    catch(DoubleDeclarationException e) {
	    	exceptions.add(e.getMessage());
	    }
    }

    public Definition lookup(Token t) {
    	return symbolTable.lookup(t.getText());
    }

    public void checkForDeclaration(Token t) {
    	Symbol s = new Symbol(t);
    	symbolTable.identifierUsage(s);

    }

    public void checkForVariable(Token t) {
    	Symbol s = new Symbol(t);
    	try {
	    	symbolTable.checkForVariable(s);
	    }
	    catch (NoVariableException nve) {
	    	exceptions.add(nve.getMessage());
	    }
	    catch (NoDeclarationException nde) {
	    	exceptions.add(nde.getMessage());
	    }
    }

    public void checkForProcedure(Token t) {
    	Symbol s = new Symbol(t);
    	try {
	    	symbolTable.checkForProcedure(s);
	    }
	    catch (NoProcedureException e) {
	    	exceptions.add(e.getMessage());
	    }
    }

    public void checkForValue(Token t) {
    	Symbol s = new Symbol(t);
    	try {
	    	symbolTable.checkForValue(s);
	    }
	    catch (NoValueException nve) {
	    	exceptions.add(nve.getMessage());
	    }
	    catch (NoDeclarationException nde) {
	    	exceptions.add(nde.getMessage());
	    }
    }

    public void resolveUnknown() {
    	try {
	    	symbolTable.resolveUnknown();
	    }
	    catch (NoDeclarationException e) {
	    	exceptions.add(e.getMessage());
	    }
    }

	public void checkRange(Token t) throws NumberOutOfRangeException {
		String s = t.getText();
		if (pendingMinus) {
			s = '-' + s;
		}
		try {
			Integer.parseInt(s);
		}
		catch (NumberFormatException e) {
			exceptions.add(new NumberOutOfRangeException(s, t.getLine(), t.getColumn()).getMessage());
		}

		pendingMinus = false;
	}

protected PL0Parser(TokenBuffer tokenBuf, int k) {
  super(tokenBuf,k);
  tokenNames = _tokenNames;
  buildTokenTypeASTClassMap();
  astFactory = new ASTFactory(getTokenTypeToASTClassMap());
}

public PL0Parser(TokenBuffer tokenBuf) {
  this(tokenBuf,1);
}

protected PL0Parser(TokenStream lexer, int k) {
  super(lexer,k);
  tokenNames = _tokenNames;
  buildTokenTypeASTClassMap();
  astFactory = new ASTFactory(getTokenTypeToASTClassMap());
}

public PL0Parser(TokenStream lexer) {
  this(lexer,1);
}

public PL0Parser(ParserSharedInputState state) {
  super(state,1);
  tokenNames = _tokenNames;
  buildTokenTypeASTClassMap();
  astFactory = new ASTFactory(getTokenTypeToASTClassMap());
}

	public final void program() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST program_AST = null;
		
		block();
		astFactory.addASTChild(currentAST, returnAST);
		match(DOT);
		program_AST = (AST)currentAST.root;
		program_AST = (AST)astFactory.make( (new ASTArray(2)).add((frontend.parsetree.ProcedureNode)astFactory.create(PROGRAM,"PROGRAM","frontend.parsetree.ProcedureNode")).add(program_AST)); resolveUnknown();
		currentAST.root = program_AST;
		currentAST.child = program_AST!=null &&program_AST.getFirstChild()!=null ?
			program_AST.getFirstChild() : program_AST;
		currentAST.advanceChildToEnd();
		program_AST = (AST)currentAST.root;
		returnAST = program_AST;
	}
	
	public final void block() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST block_AST = null;
		
		{
		switch ( LA(1)) {
		case LITERAL_CONST:
		{
			constdecl();
			break;
		}
		case IDENT:
		case QUESTION:
		case EXCLAM:
		case DOT:
		case SEMICOLON:
		case LITERAL_VAR:
		case LITERAL_PROCEDURE:
		case LITERAL_CALL:
		case LITERAL_BEGIN:
		case LITERAL_IF:
		case LITERAL_WHILE:
		{
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		{
		switch ( LA(1)) {
		case LITERAL_VAR:
		{
			vardecl();
			break;
		}
		case IDENT:
		case QUESTION:
		case EXCLAM:
		case DOT:
		case SEMICOLON:
		case LITERAL_PROCEDURE:
		case LITERAL_CALL:
		case LITERAL_BEGIN:
		case LITERAL_IF:
		case LITERAL_WHILE:
		{
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		{
		_loop6:
		do {
			if ((LA(1)==LITERAL_PROCEDURE)) {
				procdecl();
				astFactory.addASTChild(currentAST, returnAST);
			}
			else {
				break _loop6;
			}
			
		} while (true);
		}
		statement();
		astFactory.addASTChild(currentAST, returnAST);
		block_AST = (AST)currentAST.root;
		returnAST = block_AST;
	}
	
	public final void constdecl() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST constdecl_AST = null;
		
		AST tmp2_AST = null;
		tmp2_AST = astFactory.create(LT(1));
		astFactory.addASTChild(currentAST, tmp2_AST);
		match(LITERAL_CONST);
		constassign();
		astFactory.addASTChild(currentAST, returnAST);
		{
		_loop9:
		do {
			if ((LA(1)==COMMA)) {
				AST tmp3_AST = null;
				tmp3_AST = astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp3_AST);
				match(COMMA);
				constassign();
				astFactory.addASTChild(currentAST, returnAST);
			}
			else {
				break _loop9;
			}
			
		} while (true);
		}
		AST tmp4_AST = null;
		tmp4_AST = astFactory.create(LT(1));
		astFactory.addASTChild(currentAST, tmp4_AST);
		match(SEMICOLON);
		constdecl_AST = (AST)currentAST.root;
		returnAST = constdecl_AST;
	}
	
	public final void vardecl() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST vardecl_AST = null;
		Token  i1 = null;
		frontend.parsetree.IdentNode i1_AST = null;
		Token  i2 = null;
		frontend.parsetree.IdentNode i2_AST = null;
		
		AST tmp5_AST = null;
		tmp5_AST = astFactory.create(LT(1));
		astFactory.addASTChild(currentAST, tmp5_AST);
		match(LITERAL_VAR);
		i1 = LT(1);
		i1_AST = (frontend.parsetree.IdentNode)astFactory.create(i1,"frontend.parsetree.IdentNode");
		astFactory.addASTChild(currentAST, i1_AST);
		match(IDENT);
		defineVar(i1);
		{
		_loop13:
		do {
			if ((LA(1)==COMMA)) {
				AST tmp6_AST = null;
				tmp6_AST = astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp6_AST);
				match(COMMA);
				i2 = LT(1);
				i2_AST = (frontend.parsetree.IdentNode)astFactory.create(i2,"frontend.parsetree.IdentNode");
				astFactory.addASTChild(currentAST, i2_AST);
				match(IDENT);
				defineVar(i2);
			}
			else {
				break _loop13;
			}
			
		} while (true);
		}
		AST tmp7_AST = null;
		tmp7_AST = astFactory.create(LT(1));
		astFactory.addASTChild(currentAST, tmp7_AST);
		match(SEMICOLON);
		vardecl_AST = (AST)currentAST.root;
		returnAST = vardecl_AST;
	}
	
	public final void procdecl() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST procdecl_AST = null;
		Token  i = null;
		frontend.parsetree.IdentNode i_AST = null;
		
		frontend.parsetree.ProcedureNode tmp8_AST = null;
		tmp8_AST = (frontend.parsetree.ProcedureNode)astFactory.create(LT(1),"frontend.parsetree.ProcedureNode");
		astFactory.makeASTRoot(currentAST, tmp8_AST);
		match(LITERAL_PROCEDURE);
		i = LT(1);
		i_AST = (frontend.parsetree.IdentNode)astFactory.create(i,"frontend.parsetree.IdentNode");
		astFactory.addASTChild(currentAST, i_AST);
		match(IDENT);
		defineProcedure(i);
		match(SEMICOLON);
		block();
		astFactory.addASTChild(currentAST, returnAST);
		match(SEMICOLON);
		popScope();
		procdecl_AST = (AST)currentAST.root;
		returnAST = procdecl_AST;
	}
	
	public final void statement() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST statement_AST = null;
		Token  i = null;
		frontend.parsetree.IdentNode i_AST = null;
		Token  i2 = null;
		frontend.parsetree.IdentNode i2_AST = null;
		Token  i3 = null;
		frontend.parsetree.IdentNode i3_AST = null;
		Token  i4 = null;
		frontend.parsetree.IdentNode i4_AST = null;
		
		{
		switch ( LA(1)) {
		case IDENT:
		{
			i = LT(1);
			i_AST = (frontend.parsetree.IdentNode)astFactory.create(i,"frontend.parsetree.IdentNode");
			astFactory.addASTChild(currentAST, i_AST);
			match(IDENT);
			checkForVariable(i);
			frontend.parsetree.AssignNode tmp11_AST = null;
			tmp11_AST = (frontend.parsetree.AssignNode)astFactory.create(LT(1),"frontend.parsetree.AssignNode");
			astFactory.makeASTRoot(currentAST, tmp11_AST);
			match(ASSIGNOP);
			expression();
			astFactory.addASTChild(currentAST, returnAST);
			break;
		}
		case LITERAL_CALL:
		{
			frontend.parsetree.CallNode tmp12_AST = null;
			tmp12_AST = (frontend.parsetree.CallNode)astFactory.create(LT(1),"frontend.parsetree.CallNode");
			astFactory.makeASTRoot(currentAST, tmp12_AST);
			match(LITERAL_CALL);
			i2 = LT(1);
			i2_AST = (frontend.parsetree.IdentNode)astFactory.create(i2,"frontend.parsetree.IdentNode");
			astFactory.addASTChild(currentAST, i2_AST);
			match(IDENT);
			checkForProcedure(i2);
			break;
		}
		case QUESTION:
		{
			frontend.parsetree.InputNode tmp13_AST = null;
			tmp13_AST = (frontend.parsetree.InputNode)astFactory.create(LT(1),"frontend.parsetree.InputNode");
			astFactory.makeASTRoot(currentAST, tmp13_AST);
			match(QUESTION);
			i3 = LT(1);
			i3_AST = (frontend.parsetree.IdentNode)astFactory.create(i3,"frontend.parsetree.IdentNode");
			astFactory.addASTChild(currentAST, i3_AST);
			match(IDENT);
			checkForVariable(i3);
			break;
		}
		case EXCLAM:
		{
			frontend.parsetree.OutputNode tmp14_AST = null;
			tmp14_AST = (frontend.parsetree.OutputNode)astFactory.create(LT(1),"frontend.parsetree.OutputNode");
			astFactory.makeASTRoot(currentAST, tmp14_AST);
			match(EXCLAM);
			i4 = LT(1);
			i4_AST = (frontend.parsetree.IdentNode)astFactory.create(i4,"frontend.parsetree.IdentNode");
			astFactory.addASTChild(currentAST, i4_AST);
			match(IDENT);
			checkForValue(i4);
			break;
		}
		case LITERAL_BEGIN:
		{
			frontend.parsetree.BeginNode tmp15_AST = null;
			tmp15_AST = (frontend.parsetree.BeginNode)astFactory.create(LT(1),"frontend.parsetree.BeginNode");
			astFactory.makeASTRoot(currentAST, tmp15_AST);
			match(LITERAL_BEGIN);
			statement();
			astFactory.addASTChild(currentAST, returnAST);
			{
			_loop18:
			do {
				if ((LA(1)==SEMICOLON)) {
					match(SEMICOLON);
					statement();
					astFactory.addASTChild(currentAST, returnAST);
				}
				else {
					break _loop18;
				}
				
			} while (true);
			}
			match(LITERAL_END);
			break;
		}
		case LITERAL_IF:
		{
			frontend.parsetree.IfNode tmp18_AST = null;
			tmp18_AST = (frontend.parsetree.IfNode)astFactory.create(LT(1),"frontend.parsetree.IfNode");
			astFactory.makeASTRoot(currentAST, tmp18_AST);
			match(LITERAL_IF);
			condition();
			astFactory.addASTChild(currentAST, returnAST);
			match(LITERAL_THEN);
			statement();
			astFactory.addASTChild(currentAST, returnAST);
			break;
		}
		case LITERAL_WHILE:
		{
			frontend.parsetree.WhileNode tmp20_AST = null;
			tmp20_AST = (frontend.parsetree.WhileNode)astFactory.create(LT(1),"frontend.parsetree.WhileNode");
			astFactory.makeASTRoot(currentAST, tmp20_AST);
			match(LITERAL_WHILE);
			condition();
			astFactory.addASTChild(currentAST, returnAST);
			match(LITERAL_DO);
			statement();
			astFactory.addASTChild(currentAST, returnAST);
			break;
		}
		case DOT:
		case SEMICOLON:
		case LITERAL_END:
		{
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		statement_AST = (AST)currentAST.root;
		returnAST = statement_AST;
	}
	
	public final void constassign() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST constassign_AST = null;
		Token  i = null;
		frontend.parsetree.IdentNode i_AST = null;
		Token  n = null;
		frontend.parsetree.NumberNode n_AST = null;
		
		i = LT(1);
		i_AST = (frontend.parsetree.IdentNode)astFactory.create(i,"frontend.parsetree.IdentNode");
		astFactory.addASTChild(currentAST, i_AST);
		match(IDENT);
		frontend.parsetree.BinrelNode tmp22_AST = null;
		tmp22_AST = (frontend.parsetree.BinrelNode)astFactory.create(LT(1),"frontend.parsetree.BinrelNode");
		astFactory.addASTChild(currentAST, tmp22_AST);
		match(EQUALS);
		n = LT(1);
		n_AST = (frontend.parsetree.NumberNode)astFactory.create(n,"frontend.parsetree.NumberNode");
		astFactory.addASTChild(currentAST, n_AST);
		match(NUMBER);
		checkRange(n); defineConst(i, n);
		constassign_AST = (AST)currentAST.root;
		returnAST = constassign_AST;
	}
	
	public final void expression() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST expression_AST = null;
		
		{
		switch ( LA(1)) {
		case PLUS:
		{
			frontend.parsetree.PlusNode tmp23_AST = null;
			tmp23_AST = (frontend.parsetree.PlusNode)astFactory.create(LT(1),"frontend.parsetree.PlusNode");
			astFactory.makeASTRoot(currentAST, tmp23_AST);
			match(PLUS);
			break;
		}
		case MINUS:
		{
			frontend.parsetree.MinusNode tmp24_AST = null;
			tmp24_AST = (frontend.parsetree.MinusNode)astFactory.create(LT(1),"frontend.parsetree.MinusNode");
			astFactory.makeASTRoot(currentAST, tmp24_AST);
			match(MINUS);
			pendingMinus = true;
			break;
		}
		case NUMBER:
		case IDENT:
		case LPAREN:
		{
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		term();
		astFactory.addASTChild(currentAST, returnAST);
		pendingMinus = false;
		{
		_loop25:
		do {
			if ((LA(1)==PLUS||LA(1)==MINUS)) {
				{
				switch ( LA(1)) {
				case PLUS:
				{
					frontend.parsetree.BinopNode tmp25_AST = null;
					tmp25_AST = (frontend.parsetree.BinopNode)astFactory.create(LT(1),"frontend.parsetree.BinopNode");
					astFactory.makeASTRoot(currentAST, tmp25_AST);
					match(PLUS);
					break;
				}
				case MINUS:
				{
					frontend.parsetree.BinopNode tmp26_AST = null;
					tmp26_AST = (frontend.parsetree.BinopNode)astFactory.create(LT(1),"frontend.parsetree.BinopNode");
					astFactory.makeASTRoot(currentAST, tmp26_AST);
					match(MINUS);
					break;
				}
				default:
				{
					throw new NoViableAltException(LT(1), getFilename());
				}
				}
				}
				term();
				astFactory.addASTChild(currentAST, returnAST);
			}
			else {
				break _loop25;
			}
			
		} while (true);
		}
		expression_AST = (AST)currentAST.root;
		returnAST = expression_AST;
	}
	
	public final void condition() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST condition_AST = null;
		
		switch ( LA(1)) {
		case LITERAL_ODD:
		{
			frontend.parsetree.OddNode tmp27_AST = null;
			tmp27_AST = (frontend.parsetree.OddNode)astFactory.create(LT(1),"frontend.parsetree.OddNode");
			astFactory.makeASTRoot(currentAST, tmp27_AST);
			match(LITERAL_ODD);
			expression();
			astFactory.addASTChild(currentAST, returnAST);
			condition_AST = (AST)currentAST.root;
			break;
		}
		case NUMBER:
		case IDENT:
		case PLUS:
		case MINUS:
		case LPAREN:
		{
			expression();
			astFactory.addASTChild(currentAST, returnAST);
			{
			switch ( LA(1)) {
			case EQUALS:
			{
				frontend.parsetree.BinrelNode tmp28_AST = null;
				tmp28_AST = (frontend.parsetree.BinrelNode)astFactory.create(LT(1),"frontend.parsetree.BinrelNode");
				astFactory.makeASTRoot(currentAST, tmp28_AST);
				match(EQUALS);
				break;
			}
			case DIAMOND:
			{
				frontend.parsetree.BinrelNode tmp29_AST = null;
				tmp29_AST = (frontend.parsetree.BinrelNode)astFactory.create(LT(1),"frontend.parsetree.BinrelNode");
				astFactory.makeASTRoot(currentAST, tmp29_AST);
				match(DIAMOND);
				break;
			}
			case LT:
			{
				frontend.parsetree.BinrelNode tmp30_AST = null;
				tmp30_AST = (frontend.parsetree.BinrelNode)astFactory.create(LT(1),"frontend.parsetree.BinrelNode");
				astFactory.makeASTRoot(currentAST, tmp30_AST);
				match(LT);
				break;
			}
			case LEQ:
			{
				frontend.parsetree.BinrelNode tmp31_AST = null;
				tmp31_AST = (frontend.parsetree.BinrelNode)astFactory.create(LT(1),"frontend.parsetree.BinrelNode");
				astFactory.makeASTRoot(currentAST, tmp31_AST);
				match(LEQ);
				break;
			}
			case GT:
			{
				frontend.parsetree.BinrelNode tmp32_AST = null;
				tmp32_AST = (frontend.parsetree.BinrelNode)astFactory.create(LT(1),"frontend.parsetree.BinrelNode");
				astFactory.makeASTRoot(currentAST, tmp32_AST);
				match(GT);
				break;
			}
			case GEQ:
			{
				frontend.parsetree.BinrelNode tmp33_AST = null;
				tmp33_AST = (frontend.parsetree.BinrelNode)astFactory.create(LT(1),"frontend.parsetree.BinrelNode");
				astFactory.makeASTRoot(currentAST, tmp33_AST);
				match(GEQ);
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			expression();
			astFactory.addASTChild(currentAST, returnAST);
			condition_AST = (AST)currentAST.root;
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		returnAST = condition_AST;
	}
	
	public final void term() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST term_AST = null;
		
		factor();
		astFactory.addASTChild(currentAST, returnAST);
		{
		_loop29:
		do {
			if ((LA(1)==TIMES||LA(1)==OVER)) {
				{
				switch ( LA(1)) {
				case TIMES:
				{
					frontend.parsetree.BinopNode tmp34_AST = null;
					tmp34_AST = (frontend.parsetree.BinopNode)astFactory.create(LT(1),"frontend.parsetree.BinopNode");
					astFactory.makeASTRoot(currentAST, tmp34_AST);
					match(TIMES);
					break;
				}
				case OVER:
				{
					frontend.parsetree.BinopNode tmp35_AST = null;
					tmp35_AST = (frontend.parsetree.BinopNode)astFactory.create(LT(1),"frontend.parsetree.BinopNode");
					astFactory.makeASTRoot(currentAST, tmp35_AST);
					match(OVER);
					break;
				}
				default:
				{
					throw new NoViableAltException(LT(1), getFilename());
				}
				}
				}
				factor();
				astFactory.addASTChild(currentAST, returnAST);
			}
			else {
				break _loop29;
			}
			
		} while (true);
		}
		term_AST = (AST)currentAST.root;
		returnAST = term_AST;
	}
	
	public final void factor() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST factor_AST = null;
		Token  i = null;
		frontend.parsetree.IdentNode i_AST = null;
		Token  n = null;
		frontend.parsetree.NumberNode n_AST = null;
		
		switch ( LA(1)) {
		case IDENT:
		{
			i = LT(1);
			i_AST = (frontend.parsetree.IdentNode)astFactory.create(i,"frontend.parsetree.IdentNode");
			astFactory.addASTChild(currentAST, i_AST);
			match(IDENT);
			checkForValue(i);
			factor_AST = (AST)currentAST.root;
			break;
		}
		case NUMBER:
		{
			n = LT(1);
			n_AST = (frontend.parsetree.NumberNode)astFactory.create(n,"frontend.parsetree.NumberNode");
			astFactory.addASTChild(currentAST, n_AST);
			match(NUMBER);
			checkRange(n);
			factor_AST = (AST)currentAST.root;
			break;
		}
		case LPAREN:
		{
			match(LPAREN);
			expression();
			astFactory.addASTChild(currentAST, returnAST);
			match(RPAREN);
			factor_AST = (AST)currentAST.root;
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		returnAST = factor_AST;
	}
	
	
	public static final String[] _tokenNames = {
		"<0>",
		"EOF",
		"<2>",
		"NULL_TREE_LOOKAHEAD",
		"EXPR",
		"BLOCK",
		"CONSTASSIGN",
		"VAR",
		"CONSTD",
		"PROC",
		"PROGRAM",
		"ASSIGNOP",
		"NUMBER",
		"IDENT",
		"PLUS",
		"MINUS",
		"TIMES",
		"OVER",
		"EQUALS",
		"DIAMOND",
		"LT",
		"LEQ",
		"GT",
		"GEQ",
		"QUESTION",
		"EXCLAM",
		"DOT",
		"\"CONST\"",
		"COMMA",
		"SEMICOLON",
		"\"VAR\"",
		"\"PROCEDURE\"",
		"\"CALL\"",
		"\"BEGIN\"",
		"\"END\"",
		"\"IF\"",
		"\"THEN\"",
		"\"WHILE\"",
		"\"DO\"",
		"\"ODD\"",
		"LPAREN",
		"RPAREN",
		"WS"
	};
	
	protected void buildTokenTypeASTClassMap() {
		tokenTypeToASTClassMap = new Hashtable();
		tokenTypeToASTClassMap.put(new Integer(10), frontend.parsetree.ProcedureNode.class);
		tokenTypeToASTClassMap.put(new Integer(11), frontend.parsetree.AssignNode.class);
		tokenTypeToASTClassMap.put(new Integer(12), frontend.parsetree.NumberNode.class);
		tokenTypeToASTClassMap.put(new Integer(13), frontend.parsetree.IdentNode.class);
		tokenTypeToASTClassMap.put(new Integer(14), frontend.parsetree.BinopNode.class);
		tokenTypeToASTClassMap.put(new Integer(15), frontend.parsetree.BinopNode.class);
		tokenTypeToASTClassMap.put(new Integer(16), frontend.parsetree.BinopNode.class);
		tokenTypeToASTClassMap.put(new Integer(17), frontend.parsetree.BinopNode.class);
		tokenTypeToASTClassMap.put(new Integer(18), frontend.parsetree.BinrelNode.class);
		tokenTypeToASTClassMap.put(new Integer(19), frontend.parsetree.BinrelNode.class);
		tokenTypeToASTClassMap.put(new Integer(20), frontend.parsetree.BinrelNode.class);
		tokenTypeToASTClassMap.put(new Integer(21), frontend.parsetree.BinrelNode.class);
		tokenTypeToASTClassMap.put(new Integer(22), frontend.parsetree.BinrelNode.class);
		tokenTypeToASTClassMap.put(new Integer(23), frontend.parsetree.BinrelNode.class);
		tokenTypeToASTClassMap.put(new Integer(24), frontend.parsetree.InputNode.class);
		tokenTypeToASTClassMap.put(new Integer(25), frontend.parsetree.OutputNode.class);
	};
	
	
	}
