package intermediate;

public abstract class TreeNode {

    protected TreeNode down;
    protected TreeNode right;

    public void addChild(TreeNode node) {
        if (node == null) {
            return;
        }
        TreeNode t = this.down;
        if (t != null) {
            while (t.right != null) {
                t = t.right;
            }
            t.right = node;
        }
        else {
            this.down = node;
        }
    }

    /** How many children does this node have? */
    public int getNumberOfChildren() {
        TreeNode t = this.down;
        int n = 0;
        if (t != null) {
            n = 1;
            while (t.right != null) {
                t = t.right;
                n++;
            }
            return n;
        }
        return n;
    }

    public TreeNode getFirstChild() {
        return down;
    }

    public TreeNode getNextSibling() {
        return right;
    }


    public void setFirstChild(TreeNode c) {
        down = c;
    }

    public void setNextSibling(TreeNode n) {
        right = n;
    }
    
	public abstract String toStringList();


}
