package intermediate.operators;

import intermediate.*;

/**
 * Konvertiert ein Expression in ein Statement. Das ist zum Beispiel ntig,
 * um einen Funktionsaufruf, der normalerweise ein Ergebnis liefert und damit
 * vom Typ Expression ist, als einfachen Prozeduraufruf nutzen zu knnen, der
 * kein Ergebnis zurckliefert und somit ein Statement ist.
 *
 * Beispiel:
 * a = func(12); => func(12) ist hier ein Expression
 * func(12);     => func(12) ist hier ein Statement
 */
public class EXP extends Statement {

    private Expression expression;

    public EXP(Expression e) {
        this.expression = e;
        addChild(e);
    }

    public String toString() {
        return "EXP";
    }

    public String toStringList() {
        return "EXP(" + expression.toStringList() + ")";
    }

}