/*
 * Created on 02.06.2004
 *
 * To change the template for this generated file go to
 * Window>Preferences>Java>Code Generation>Code and Comments
 */
package backend;

import java.util.*;

import intermediate.*;
import intermediate.operators.*;

/**
 * @author user
 *
 * To change the template for this generated type comment go to
 * Window>Preferences>Java>Code Generation>Code and Comments
 */
public class LinearImm {

    private List list;
    private List completeCode;


    public LinearImm(){
    }


    public List createLinearImmList(CodeContainer originalCC){
        completeCode = new LinkedList();
        //for (Iterator it = originalCC.keySet().iterator(); it.hasNext();) {
        for (int i = 0; i < originalCC.size(); i++) {
            list = new LinkedList();
            Integer key = new Integer(i);
            //parse codeTree and save instructions inside the list...

            //first add the start procedure Label
            //Label procstart = new Label("Procedure" + key.intValue());
            //list.add(new LABEL(procstart));

            //second add the FrameBuild Instruction
            //list.add (new FrameBuild(key.intValue()));
            //insert all procedure instructions
            parseRLW((intermediate.TreeNode)originalCC.getCode(key.intValue()));

            //last add the destroy Frame instruction
            //list.add (new FrameLeave(key.intValue()));

            completeCode.add(list);
        }

        return completeCode;
    }



    public TreeNode parseRLW(intermediate.TreeNode node){

        int num;	//number of childs at the actual node
        num = node.getNumberOfChildren();

        if(node == null){
            //System.out.println("got null");
            return null;
        }



        if((node instanceof BINOP)){
            Expression src1 = (Expression)parseRLW(node.getFirstChild());
            Expression src2 = (Expression)parseRLW(node.getFirstChild().getNextSibling());


            Expression result = new TEMP(new Temp());

            int op = ((BINOP)node).getOperatorInt();
            BINOP operation =new BINOP(op, result, src1, src2);
//			list.add(operation);
            MOVE moveOp = new MOVE(result, operation);
            list.add(moveOp);

//			System.out.println(operation.toStringList());
            return result;
        }
        if(node instanceof CONST){
            return node;
        }
        if(node instanceof TEMP){
            return node;
        }
        if(node instanceof MEM){
            Expression src1 = (Expression)parseRLW(node.getFirstChild());

            MEM result = new MEM(src1);
//			System.out.println(result.toString());
            return result;
        }
        if(node instanceof MOVE){
            Expression src1 = (Expression)parseRLW(node.getFirstChild());
            Expression src2 = (Expression)parseRLW(node.getFirstChild().getNextSibling());

            MOVE operation = new MOVE(src1, src2);
//			System.out.println(operation.toStringList());

            list.add(operation);
            return null;
        }
        if(node instanceof LABEL){
//			System.out.println(node.toStringList());
            list.add(node);
            return null;
        }
        if(node instanceof JUMP){
//			System.out.println(node.toStringList());
            list.add(node);
            return null;
        }
        if(node instanceof CJUMP){
            Expression src1 = (Expression)parseRLW(node.getFirstChild());
            Expression src2 = (Expression)parseRLW(node.getFirstChild().getNextSibling());
            int relation = ((CJUMP)node).getRelopInt();
            Label iftrue = ((CJUMP)node).getTrueLabel();
            Label iffalse = ((CJUMP)node).getFalseLabel();

            CJUMP operation = new CJUMP(relation, src1, src2, iftrue, iffalse);

//			System.out.println(operation.toStringList());
            list.add(operation);
            return null;

        }
        if(node instanceof INPUT){

            Expression src1 = (Expression)parseRLW(node.getFirstChild());
            list.add(new INPUT((MEM)src1));

//			list.add(node);
//			System.out.println(node.toStringList());
            return null;
        }
        if(node instanceof OUTPUT){
            Expression src1 = (Expression)parseRLW(node.getFirstChild());
            OUTPUT operation = new OUTPUT(src1);
            list.add(operation);

//			System.out.println(operation.toStringList());
            return null;
        }
        if(node instanceof CALL){
            Expression src1 = (Expression)parseRLW(node.getFirstChild());
//
//			int destnumber = ((CONST)src1).getValue();
//			Label destination = new Label("Procedure" + destnumber);
//			JUMP operation = new JUMP(destination);

            CALL operation = new CALL(src1);

            //list.add(operation);
//			System.out.println(operation.toStringList());
            return operation;
        }
        if(node instanceof EXP){
            Expression src1 = (Expression)parseRLW(node.getFirstChild());

            EXP exp = new EXP(src1);

            list.add(exp);
//			System.out.println(operation.toStringList());
            return null;
        }


        if(num == 1){//recursive with FirstChild
            parseRLW(node.getFirstChild());

        }else if(num == 2){//recursive with FirstChild + FirstChild->nextSibling
        parseRLW(node.getFirstChild());
        parseRLW(node.getFirstChild().getNextSibling());


        }



        return null;


    }

}
