package frontend.parsetree;

import antlr.Token;
import intermediate.*;
import intermediate.operators.*;

public class BinopNode extends PL0Node {

    public BinopNode(Token tok) {
        super(tok);
    }

    public Statement convertStatement() {
        return null;
    };

    public Expression convertExpression() {
        PL0Node op1 = (PL0Node)getFirstChild();
        PL0Node op2 = (PL0Node)op1.getNextSibling();
        return new BINOP(getNodeType(), op1.convertExpression(), op2.convertExpression());
    }


    private int getNodeType() {
        String node = getText();
        if (node.equals("+")) {
            return BINOP.PLUS;
        }
        if (node.equals("-")) {
            return BINOP.MINUS;
        }
        if (node.equals("*")) {
            return BINOP.MUL;
        }
        if (node.equals("/")) {
            return BINOP.DIV;
        }
        return -1;
    }

}
