package frontend.parsetree;

import antlr.Token;
import intermediate.*;
import intermediate.operators.*;
import frontend.symbol.*;
import frontend.PL0Frontend;
import intermediate.frame.*;

public class IdentNode extends PL0Node {


    private Frame frame;

    public IdentNode(Token tok) {
        super(tok);
        frame = new PL0Frontend().getCompiler().getBackend().getFrame();
    }

    public Statement convertStatement() {
        return null;
    };

    public Expression convertExpression() {
        int[] pos = SymbolTable.getSymbolTable().lookupPos(getText());
        Expression ident = new TEMP(frame.fp());
        for (int i = 0; i < pos[0]; i++) {
            ident = new MEM(new BINOP(BINOP.PLUS, ident, new CONST(frame.STATIC_LINK  * frame.wordSize())));
        }
        ident = new MEM(new BINOP(BINOP.PLUS, ident, new CONST((pos[1] + frame.getMinOffset()) * frame.wordSize())));
        return ident;
    }
}
