package frontend.symbol;

import java.util.*;

/**
 * Stack, der von der Symboltabelle benutzt wird, um die Sichtbarkeitsbereiche zu verwalten.
 */
class ScopeStack extends java.util.Stack {

    /**
     * Sucht nach einer Definition im Stack
     */
    public Definition lookup(String name) {
        // unfortunately, the enumeration of a stack returns it
        // in the reverse order in which we want to traverse it...
        // So we must walk manually...
        /*for(int i = size()-1; i > -1; i--) {
            Definition d = ((ScopeDef)elementAt(i)).lookup(name);
            if (d != null) {
                return d;
            }
        }
        return null;*/
        return ((ScopeDef)elementAt(size() - 1)).lookup(name);
    }

    public int[] lookupPos(String name) {
        int[] posarray = new int[]{0,0};
        Definition d = null;
        while (posarray[0] < size() && d == null) {
            Hashtable scopeElems = ((ScopeDef)elementAt(size()-posarray[0]-1)).getElements();
            d = (Definition)scopeElems.get(name);
            posarray[0]++;
        }
        posarray[0]--;
        posarray[1] = d.getPosInScope();
        return posarray;
    }


}
